<template>
    <v-container>

        <v-simple-table dense>
            <template v-slot:default>
                <thead>
                <tr>
                    <th class="text-left">Name</th>
                    <th class="text-left">Id</th>
                    <th class="text-left">Create At</th>
                </tr>
                </thead>
                <tbody>
                <tr class='tr' v-for="f in floorPlans" :key="f.name">
                    <td>{{ f.name }}</td>
                    <td>{{ f.id }}</td>
                    <td>{{ f.timeStamp }}</td>
                </tr>
                </tbody>
            </template>
        </v-simple-table>
    </v-container>
</template>

<style lang='scss' scoped>

    .tr{
        &:first-child{
            color: cyan;
        }
    }

</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import {coreApi} from "../init";
    import {FloorResponse} from "../../../classLibrary/core/floorResponse";
    import moment from "moment";
    import "moment-timezone";

    const props = {
        floor: String
    };

    const Base = Vue.extend({props});

    interface DisplayFloorPlan {
        id: string;
        name: string;
        timeStamp: string;
    }

    @Component({props})
    export default class FloorPlans extends Base {

        floorPlans: DisplayFloorPlan[] = [];

        async created() {
            const r = await coreApi.Get<FloorResponse>(`Floor/${this.floor}`);
            if (r.Ok) {
                this.floorPlans = r.Ok.floorPlans.Map(x => {
                    const ts = moment(x.timeStamp).tz(r.Ok!.info.timeZone).calendar();
                    return {
                        id: x.id, timeStamp: ts, name: x.name
                    } as DisplayFloorPlan
                });
            } else {
                (this.$parent as any).error = r.error!;
            }

        }
    }
</script>
